# Uses of Class
nu.xom.Node

Packages that use Node
Package
Description
nu.xom
`nu.xom` is the core package of XOM that contains all the basic classes representing the different kinds of nodes: elements, attributes, comments, text nodes, and so forth.
nu.xom.canonical
`nu.xom.canonical` supports the output of Canonical XML from XOM.
nu.xom.tests
`nu.xom.tests` contains the JUnit based test suite for XOM.

## Uses of Node in nu.xom

Subclasses of Node in nu.xom
Modifier and Type
Class
Description
`class`
`Attribute`
This class represents an attribute such as `type="empty"` or `xlink:href="http://www.example.com"`.
`class`
`Comment`
This class represents an XML comment such as `<-- This is a comment-->`.
`class`
`DocType`
Represents an XML document type declaration such as `<!DOCTYPE book SYSTEM "docbookx.dtd">`.
`class`
`Document`
The `Document` class represents a complete XML document including its root element, prolog, and epilog.
`class`
`Element`
This class represents an XML element.
`final class`
`Namespace`
Represents a namespace in scope.
`class`
`ParentNode`
The generic superclass for nodes that have children.
`class`
`ProcessingInstruction`
This class represents an XML processing instruction.
`class`
`Text`
This class represents a run of text.
Classes in nu.xom that implement interfaces with type arguments of type Node
Modifier and Type
Class
Description
`final class`
`Nodes`
Implements a list of nodes for traversal purposes.
Methods in nu.xom that return Node
Modifier and Type
Method
Description
`Node`
DocType.`copy()`
Returns a copy of this `DocType` which has the same system ID, public ID, root element name, and internal DTD subset, but does not belong to a document.
`abstract Node`
Node.`copy()`
Returns a deep copy of this node with no parent, that can be added to the current document or a different one.
`Node`
Nodes.`get(int index)`
Returns the indexth node in the list.
`final Node`
Attribute.`getChild(int position)`
Throws `IndexOutOfBoundsException` because attributes do not have children.
`final Node`
Comment.`getChild(int position)`
Throws `IndexOutOfBoundsException` because comments do not have children.
`final Node`
DocType.`getChild(int position)`
Throws `IndexOutOfBoundsException` because document type declarations do not have children.
`Node`
Namespace.`getChild(int position)`
Throws `IndexOutOfBoundsException` because namespaces do not have children.
`abstract Node`
Node.`getChild(int position)`
Returns the child of this node at the specified position.
`Node`
ParentNode.`getChild(int position)`
Returns the child of this node at the specified position.
`final Node`
ProcessingInstruction.`getChild(int position)`
Throws `IndexOutOfBoundsException` because processing instructions do not have children.
`final Node`
Text.`getChild(int position)`
Throws `IndexOutOfBoundsException` because texts do not have children.
`Node`
Nodes.`remove(int index)`
Removes the indexthnode in the list.
`Node`
Document.`removeChild(int position)`
Removes the child of this document at the specified position.
`Node`
Document.`removeChild(Node child)`
Removes the specified child from this document.
`Node`
ParentNode.`removeChild(int position)`
Removes the child of this node at the specified position.
`Node`
ParentNode.`removeChild(Node child)`
Removes the specified child of this node.
Methods in nu.xom that return types with arguments of type Node
Modifier and Type
Method
Description
`Iterator<Node>`
Nodes.`iterator()`
Methods in nu.xom with parameters of type Node
Modifier and Type
Method
Description
`void`
Nodes.`append(Node node)`
Adds a node at the end of this list.
`void`
ParentNode.`appendChild(Node child)`
Appends a node to the children of this node.
`boolean`
Nodes.`contains(Node node)`
Determines whether a node is contained in this list.
`int`
ParentNode.`indexOf(Node child)`
Returns the position of a node within the children of this node.
`void`
Nodes.`insert(Node node, int index)`
Inserts a node at the indexth position in the list.
`void`
ParentNode.`insertChild(Node child, int position)`
Inserts a child node at the specified position.
`Node`
Document.`removeChild(Node child)`
Removes the specified child from this document.
`Node`
ParentNode.`removeChild(Node child)`
Removes the specified child of this node.
`void`
Document.`replaceChild(Node oldChild, Node newChild)`
Replaces an existing child with a new child node.
`void`
ParentNode.`replaceChild(Node oldChild, Node newChild)`
Replaces an existing child with a new child node.
`protected void`
Serializer.`writeChild(Node node)`
Writes a child node onto the output stream using the current options.
Constructors in nu.xom with parameters of type Node
Modifier
Constructor
Description
``
`Nodes(Node node)`
Creates a node list containing a single node.

## Uses of Node in nu.xom.canonical

Methods in nu.xom.canonical with parameters of type Node
Modifier and Type
Method
Description
`final void`
Canonicalizer.`write(Node node)`
Serializes a node onto the output stream using the specified canonicalization algorithm.

## Uses of Node in nu.xom.tests

Methods in nu.xom.tests with parameters of type Node
Modifier and Type
Method
Description
`static void`
XOMTestCase.`assertEquals(String message, Node expected, Node actual)`
Asserts that two nodes are equal.
`static void`
XOMTestCase.`assertEquals(Node expected, Node actual)`
Asserts that two nodes are equal.